# Generated by Django 3.0.2 on 2020-02-02 14:16

from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='CesarCipher',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('shift', models.IntegerField()),
            ],
        ),
        migrations.CreateModel(
            name='Field',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=255)),
            ],
        ),
        migrations.CreateModel(
            name='Player',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=255)),
                ('identifier', models.IntegerField()),
                ('cipher', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, related_name='player', to='game.CesarCipher')),
            ],
        ),
        migrations.CreateModel(
            name='TheWorld',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
            ],
        ),
        migrations.CreateModel(
            name='Unit',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=255)),
                ('category', models.CharField(max_length=255)),
                ('current_action', models.CharField(max_length=255)),
                ('field', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='units', to='game.Field')),
                ('player', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='units', to='game.Player')),
            ],
        ),
        migrations.CreateModel(
            name='Territory',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=255)),
                ('world', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='territories', to='game.TheWorld')),
            ],
        ),
        migrations.AddField(
            model_name='player',
            name='territory',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='players', to='game.Territory'),
        ),
        migrations.AddField(
            model_name='field',
            name='territory',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='fields', to='game.Territory'),
        ),
        migrations.CreateModel(
            name='Command',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('origin', models.CharField(max_length=255)),
                ('target', models.CharField(max_length=255)),
                ('action', models.CharField(max_length=255)),
                ('unit', models.CharField(max_length=255)),
                ('player', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='commands', to='game.Player')),
            ],
        ),
    ]
